Index: trunk/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 21)
+++ trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 56)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.
+ * granted under this license.  
  *
- * Copyright (c) 2010-2011, ISO/IEC
+ * Copyright (c) 2010-2012, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -15,5 +15,5 @@
  *    this list of conditions and the following disclaimer in the documentation
  *    and/or other materials provided with the distribution.
- *  * Neither the name of the ISO/IEC nor the names of its contributors may
+ *  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
  *    be used to endorse or promote products derived from this software without
  *    specific prior written permission.
@@ -32,6 +32,4 @@
  */
 
-
-
 /** \file     TComPrediction.cpp
     \brief    prediction class
@@ -41,4 +39,7 @@
 #include "TComPrediction.h"
 
+//! \ingroup TLibCommon
+//! \{
+
 // ====================================================================================================================
 // Constructor / destructor / initialize
@@ -53,6 +54,5 @@
 TComPrediction::~TComPrediction()
 {
-  m_cYuvExt.destroy();
-
+  
   delete[] m_piYuvExt;
 
@@ -62,8 +62,18 @@
   m_cYuvPredTemp.destroy();
 
-#if LM_CHROMA  
   if( m_pLumaRecBuffer )
-    delete [] m_pLumaRecBuffer;  
-#endif
+  {
+    delete [] m_pLumaRecBuffer;
+  }
+  
+  Int i, j;
+  for (i = 0; i < 4; i++)
+  {
+    for (j = 0; j < 4; j++)
+    {
+      m_filteredBlock[i][j].destroy();
+    }
+    m_filteredBlockTmp[i].destroy();
+  }
 }
 
@@ -72,7 +82,17 @@
   if( m_piYuvExt == NULL )
   {
+    Int extWidth  = g_uiMaxCUWidth + 16; 
+    Int extHeight = g_uiMaxCUHeight + 1;
+    Int i, j;
+    for (i = 0; i < 4; i++)
+    {
+      m_filteredBlockTmp[i].create(extWidth, extHeight + 7);
+      for (j = 0; j < 4; j++)
+      {
+        m_filteredBlock[i][j].create(extWidth, extHeight);
+      }
+    }
     m_iYuvExtHeight  = ((g_uiMaxCUHeight + 2) << 4);
     m_iYuvExtStride = ((g_uiMaxCUWidth  + 8) << 4);
-    m_cYuvExt.create( m_iYuvExtStride, m_iYuvExtHeight );
     m_piYuvExt = new Int[ m_iYuvExtStride * m_iYuvExtHeight ];
 
@@ -84,11 +104,11 @@
   }
 
-#if LM_CHROMA                      
   m_iLumaRecStride =  (g_uiMaxCUWidth>>1) + 1;
   m_pLumaRecBuffer = new Pel[ m_iLumaRecStride * m_iLumaRecStride ];
 
-  for( Int i = 1; i < 66; i++ )
+  for( Int i = 1; i < 64; i++ )
+  {
     m_uiaShift[i-1] = ( (1 << 15) + i/2 ) / i;
-#endif
+  }
 }
 
@@ -106,21 +126,33 @@
   {
     for (iInd = 0;iInd < iWidth;iInd++)
+    {
       iSum += pSrc[iInd-iSrcStride];
+    }
   }
   if (bLeft)
   {
     for (iInd = 0;iInd < iHeight;iInd++)
+    {
       iSum += pSrc[iInd*iSrcStride-1];
+    }
   }
 
   if (bAbove && bLeft)
+  {
     pDcVal = (iSum + iWidth) / (iWidth + iHeight);
+  }
   else if (bAbove)
+  {
     pDcVal = (iSum + iWidth/2) / iWidth;
+  }
   else if (bLeft)
+  {
     pDcVal = (iSum + iHeight/2) / iHeight;
+  }
   else
+  {
     pDcVal = pSrc[-1]; // Default DC value already calculated and placed in the prediction array if no neighbors are available
-
+  }
+  
   return pDcVal;
 }
@@ -147,5 +179,5 @@
  * from the extended main reference.
  */
-Void TComPrediction::xPredIntraAng( Int* pSrc, Int srcStride, Pel*& rpDst, Int dstStride, UInt width, UInt height, UInt dirMode, Bool blkAboveAvailable, Bool blkLeftAvailable )
+Void TComPrediction::xPredIntraAng( Int* pSrc, Int srcStride, Pel*& rpDst, Int dstStride, UInt width, UInt height, UInt dirMode, Bool blkAboveAvailable, Bool blkLeftAvailable, Bool bFilter )
 {
   Int k,l;
@@ -154,8 +186,16 @@
 
   // Map the mode index to main prediction direction and angle
+#if LOGI_INTRA_NAME_3MPM
+  assert( dirMode > 0 ); //no planar
+  Bool modeDC        = dirMode < 2;
+  Bool modeHor       = !modeDC && (dirMode < 18);
+  Bool modeVer       = !modeDC && !modeHor;
+  Int intraPredAngle = modeVer ? (Int)dirMode - VER_IDX : modeHor ? -((Int)dirMode - HOR_IDX) : 0;
+#else
   Bool modeDC        = dirMode == 0;
   Bool modeVer       = !modeDC && (dirMode < 18);
   Bool modeHor       = !modeDC && !modeVer;
   Int intraPredAngle = modeVer ? dirMode - 9 : modeHor ? dirMode - 25 : 0;
+#endif
   Int absAng         = abs(intraPredAngle);
   Int signAng        = intraPredAngle < 0 ? -1 : 1;
@@ -223,4 +263,5 @@
       }
       refMain = modeVer ? refAbove : refLeft;
+      refSide = modeVer ? refLeft  : refAbove;
     }
 
@@ -232,4 +273,16 @@
         {
           pDst[k*dstStride+l] = refMain[l+1];
+        }
+      }
+
+      if ( bFilter )
+      {
+        for (k=0;k<blkSize;k++)
+        {
+#if REMOVE_DIV_OPERATION
+          pDst[k*dstStride] = Clip ( pDst[k*dstStride] + (( refSide[k+1] - refSide[0] ) >> 1) );
+#else
+          pDst[k*dstStride] = Clip ( pDst[k*dstStride] + ( refSide[k+1] - refSide[0] ) / 2 );
+#endif
         }
       }
@@ -290,147 +343,32 @@
   Int *ptrSrc;
 
-  // only assign variable in debug mode
-#ifndef NDEBUG
-  // get intra direction
-  Int iIntraSizeIdx = g_aucConvertToBit[ iWidth ] + 1;
-
-  assert( iIntraSizeIdx >= 1 ); //   4x  4
-  assert( iIntraSizeIdx <= 6 ); // 128x128
+  assert( g_aucConvertToBit[ iWidth ] >= 0 ); //   4x  4
+  assert( g_aucConvertToBit[ iWidth ] <= 5 ); // 128x128
   assert( iWidth == iHeight  );
-#endif //NDEBUG
-
-#if QC_MDIS
-  ptrSrc = pcTComPattern->getPredictorPtr( uiDirMode, g_aucConvertToBit[ iWidth ] + 1, iWidth, iHeight, m_piYuvExt );
-#else
-  ptrSrc = pcTComPattern->getAdiOrgBuf( iWidth, iHeight, m_piYuvExt );
-#endif //QC_MDIS
+
+  ptrSrc = pcTComPattern->getPredictorPtr( uiDirMode, g_aucConvertToBit[ iWidth ] + 2, m_piYuvExt );
 
   // get starting pixel in block
-  Int sw = ( iWidth<<1 ) + 1;
-
-#if ADD_PLANAR_MODE
+  Int sw = 2 * iWidth + 1;
+
+  // Create the prediction
   if ( uiDirMode == PLANAR_IDX )
   {
-#if REFERENCE_SAMPLE_PADDING
     xPredIntraPlanar( ptrSrc+sw+1, sw, pDst, uiStride, iWidth, iHeight );
-#else
-    xPredIntraPlanar( ptrSrc+sw+1, sw, pDst, uiStride, iWidth, iHeight, bAbove, bLeft );
-#endif
-    return;
-  }
-#endif
-
-  // get converted direction
-  uiDirMode = g_aucAngIntraModeOrder[ uiDirMode ];
-
-  // Create the prediction
-  xPredIntraAng( ptrSrc+sw+1, sw, pDst, uiStride, iWidth, iHeight, uiDirMode, bAbove,  bLeft );
-
-#if MN_DC_PRED_FILTER
-  if ((uiDirMode == 0) && pcTComPattern->getDCPredFilterFlag())
-    xDCPredFiltering( ptrSrc+sw+1, sw, pDst, uiStride, iWidth, iHeight);
-#endif
-}
-
-
-Void 
-TComPrediction::predIntraDepthAng(TComPattern* pcTComPattern, UInt uiDirMode, Pel* piPred, UInt uiStride, Int iWidth, Int iHeight )
-{
-  Pel*  pDst    = piPred;
-  Int*  ptrSrc  = pcTComPattern->getAdiOrgBuf( iWidth, iHeight, m_piYuvExt );
-  Int   sw      = ( iWidth<<1 ) + 1;
-  uiDirMode     = g_aucAngIntraModeOrder[ uiDirMode ];
-  xPredIntraAngDepth( ptrSrc+sw+1, sw, pDst, uiStride, iWidth, iHeight, uiDirMode );
-}
-
-Int
-TComPrediction::xGetDCDepth( Int* pSrc, Int iDelta, Int iBlkSize )
-{
-  Int iDC    = PDM_UNDEFINED_DEPTH;
-  Int iSum   = 0;
-  Int iNum   = 0;
-  for( Int k = 0; k < iBlkSize; k++, pSrc += iDelta )
-  {
-    if( *pSrc != PDM_UNDEFINED_DEPTH )
-    {
-      iSum += *pSrc;
-      iNum ++;
-    }
-  }
-  if( iNum )
-  {
-    iDC = ( iSum + ( iNum >> 1 ) ) / iNum;
-  }
-  return iDC;
-}
-
-Int
-TComPrediction::xGetDCValDepth( Int iVal1, Int iVal2, Int iVal3, Int iVal4 )
-{
-  if     ( iVal1 != PDM_UNDEFINED_DEPTH )   return iVal1;
-  else if( iVal2 != PDM_UNDEFINED_DEPTH )   return iVal2;
-  else if( iVal3 != PDM_UNDEFINED_DEPTH )   return iVal3;
-  return   iVal4;
-}
-
-Void 
-TComPrediction::xPredIntraAngDepth( Int* pSrc, Int srcStride, Pel* pDst, Int dstStride, UInt width, UInt height, UInt dirMode )
-{
-  AOF( width == height );
-  Int blkSize       = width;
-  Int iDCAbove      = xGetDCDepth( pSrc - srcStride,                               1, blkSize );
-  Int iDCAboveRight = xGetDCDepth( pSrc - srcStride + blkSize,                     1, blkSize );
-  Int iDCLeft       = xGetDCDepth( pSrc -         1,                       srcStride, blkSize );
-  Int iDCBelowLeft  = xGetDCDepth( pSrc -         1 + blkSize * srcStride, srcStride, blkSize );
-  Int iWgt, iDC1, iDC2;
-  if( dirMode == 0 ) // 0
-  {
-    iDC1  = xGetDCValDepth( iDCAbove, iDCAboveRight, iDCLeft,  iDCBelowLeft  );
-    iDC2  = xGetDCValDepth( iDCLeft,  iDCBelowLeft,  iDCAbove, iDCAboveRight );
-    iWgt  = 8;
-  }
-  else if( dirMode < 10 ) // 1..9
-  {
-    iDC1  = xGetDCValDepth( iDCAbove, iDCAboveRight, iDCLeft,  iDCBelowLeft  );
-    iDC2  = xGetDCValDepth( iDCLeft,  iDCBelowLeft,  iDCAbove, iDCAboveRight );
-    iWgt  = 7 + dirMode;
-  }
-  else if( dirMode < 18 ) // 10..17
-  {
-    iDC1  = xGetDCValDepth( iDCAbove, iDCAboveRight, iDCLeft,  iDCBelowLeft  );
-    iDC2  = xGetDCValDepth( iDCAboveRight, iDCAbove, iDCLeft,  iDCBelowLeft  );
-    iWgt  = 25 - dirMode;
-  }
-  else if( dirMode < 26 ) // 18..25
-  {
-    iDC1  = xGetDCValDepth( iDCAbove, iDCAboveRight, iDCLeft,  iDCBelowLeft  );
-    iDC2  = xGetDCValDepth( iDCLeft,  iDCBelowLeft,  iDCAbove, iDCAboveRight );
-    iWgt  = 25 - dirMode;
-  }
-  else if( dirMode < 34 )  // 26..33
-  {
-    iDC1  = xGetDCValDepth( iDCLeft,  iDCBelowLeft,  iDCAbove, iDCAboveRight );
-    iDC2  = xGetDCValDepth( iDCBelowLeft,  iDCLeft,  iDCAbove, iDCAboveRight );
-    iWgt  = 41 - dirMode;
-  }
-  else // 34 (wedgelet -> use simple DC prediction
-  {
-    iDC1  = xGetDCValDepth( iDCAbove, iDCAboveRight, iDCLeft,  iDCBelowLeft  );
-    iDC2  = xGetDCValDepth( iDCLeft,  iDCBelowLeft,  iDCAbove, iDCAboveRight );
-    iWgt  = 8;
-  }
-  Int iWgt2   = 16 - iWgt;
-  Int iDCVal  = ( iWgt * iDC1 + iWgt2 * iDC2 + 8 ) >> 4;
-  
-  // set depth
-  for( Int iY = 0; iY < blkSize; iY++, pDst += dstStride )
-  {
-    for( Int iX = 0; iX < blkSize; iX++ )
-    {
-      pDst[ iX ] = iDCVal;
-    }
-  }
-}
-
+  }
+  else
+  {
+#if LOGI_INTRA_NAME_3MPM
+    xPredIntraAng( ptrSrc+sw+1, sw, pDst, uiStride, iWidth, iHeight, uiDirMode, bAbove, bLeft, true );
+#else
+    xPredIntraAng( ptrSrc+sw+1, sw, pDst, uiStride, iWidth, iHeight, g_aucAngIntraModeOrder[ uiDirMode ], bAbove, bLeft, true );
+#endif
+
+    if( (uiDirMode == DC_IDX ) && bAbove && bLeft )
+    {
+      xDCPredFiltering( ptrSrc+sw+1, sw, pDst, uiStride, iWidth, iHeight);
+    }
+  }
+}
 
 // Angular chroma
